import { Component, OnInit } from '@angular/core';
import { AuthService } from '@app/core/services/auth/auth.service';
import { ActivatedRoute } from '@angular/router';

@Component( {
  selector: 'app-register',
  templateUrl: './register.component.html',
  styleUrls: [ './register.component.css' ]
} )
export class RegisterComponent implements OnInit {

  public openState = {
    login: true,
    newAccount: false,
  };

  constructor( public authService: AuthService, private route: ActivatedRoute ) {
  }

  ngOnInit() {
    this.route.queryParams.forEach( ( val ) => {
      if ( val.hasOwnProperty( 'new-account' ) ) {
        this.newAccountClick();
      }
    } );
  }

  // Clicks
  public loginClick(): void {
    this.openState.newAccount = false;
    this.openState.login = !this.openState.login;
  }

  public newAccountClick(): void {
    this.openState.login = false;
    this.openState.newAccount = !this.openState.newAccount;
  }

}
